#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
void input(void);
void dlcs(void);
int rows(void);
void avgnum(void);
void letterschange(void);
char fname[100];
int main(void)
{
    char choice;
    
    do{
         printf("Input file name (like '****.c'): ");
		 scanf("%s", fname); 
    }while(fname[strlen(fname)-2]!='.'&&fname[strlen(fname)-1]!='c');
      
    do{
         printf("\nChoose an option:\n");
         printf("1. Input source code in %s\n",fname);
         printf("2. Find the number of numbers/letters - the capital and non-capital letters.\n");
         printf("3. Find the average number of capital and non-capital letters.\n");
         printf("4. Change lowercase letters to uppercase and uppercase letters to lowercase.\n");
         printf("5. Quit\n");

         printf("\nWhat's your choice?: ");
         choice=getche();
         
         switch(choice){
                       case '1': { 
                            printf ("\nYour choice is 1!\n\n");
                            input();break;
                            }
                       case '2': { 
                            printf ("\nYour choice is 2!\n\n");
                            dlcs();break;
                            }
                       case '3': {
                            printf ("\nYour choice is 3!\n\n");
                            avgnum();break;
                            }
                       case '4':{
                            printf ("\nYour choice is 4!\n\n");
                            letterschange();break;	
                            }
                       case '5':{
                            printf("\nGoodbye\n\n");
                            return 0;
                            }
                       default: {
                                printf("\nInvalid choice\n\n");	
                                }
         }
     }while(choice!=5);
     
     printf("\nGoodbye\n\n");

     system ("PAUSE");
     return 0;
}
void input(void)
{
     FILE  *out;
     int c;
     
     out=fopen(fname, "w");
     if(out==NULL){
                   printf("FAIL !!!");
                   exit(EXIT_FAILURE);
                  }
     else{
          printf("\nInput text: ");
          do{
                          c=fgetc(stdin);
                          if(feof(stdin))break;
                          fputc(c,out);
          }while (c!=EOF);
          printf("\nThe input was saved!\n\n");
         }
          fclose(out);
}
void dlcs(void)
{
     FILE *fp;
     int  numbers=0, letters=0, smallet=0, caplet=0, line=0;
     char c[200];
     fp=fopen(fname,"r");
     
     if(fp==NULL){
                  printf("\nFAIL !!!\n\n");
                  exit(EXIT_FAILURE);
                 }
     
     int pos;
     
     while(fgets(c,sizeof(c),fp)!=NULL)
     { 
         
              pos=0;    
         while(c[pos]!='\n'){
                     
                     if(isdigit(c[pos])) numbers++;
                     else if (isalpha(c[pos]))  {
                          letters++;
                          if(isupper(c[pos])) caplet++;
                          else
                          smallet++;
  
                          }
                 pos++;    
         }
         
         
         line++;            
         printf("\n\nLine number %d\n", line);
         printf("\nThe number of numbers is: %d", numbers);
         printf("\nThe number of letters is: %d", letters);
         printf("\nThe number of capital letters is: %d", caplet);
         printf("\nThe number of small letters is: %d", smallet);
         printf ("\n");
         
         numbers=letters=caplet=smallet=0;
         
     }              
     
     fclose(fp);     
}
void avgnum(void)
{
     FILE *fp;
	 int c;
	 float q=0, n=0, l=0;
	 fp=fopen(fname,"r");
	
	 if(fp==NULL){
                  printf("\nFAIL !!!\n\n");
	              exit(EXIT_FAILURE);
	             }
     do{
                  c=getc(fp);
                  if(c>='A' && c<='Z') n++;
                  if(c>='a' && c<='z') l++;
     }while(c!=EOF);
	
     fclose(fp);
     q=rows();
     printf("\n\nThe average number of Uppercase letters per line is: %.2f", n/q);
     printf("\n\nThe average number of Lowercase letters per line is: %.2f", l/q);
     printf("\n\n");
}
int rows(void)
{
     FILE *fp;
	 int c;
	 int q=0;
	 fp = fopen(fname,"r");
	
	 if(fp==NULL){
                  printf("\nFAIL !!!\n\n");
	              exit(EXIT_FAILURE);
	             }
     do{
                  if(c=='\n') q++;
		          c = getc(fp);
     }while(c!=EOF);
                
     fclose(fp);

     return q;
}     
void letterschange(void){
     FILE *fp, *out;
     int c;
     fp=fopen(fname, "r");
     out=fopen("Letters.c","w");
     
     if(fp==NULL){
                  printf("\nThere is no text in text.txt\n\n");
                  exit(EXIT_FAILURE);
                  }
     else{
          do{
             c=fgetc(fp);
             if(feof(fp))break;
             if((c>='A')&&(c<='Z')) fputc(tolower(c),out);
             else if((c>='a')&&(c<='z')) fputc(toupper(c),out);
          }while(c!=EOF);
     
     fclose(fp);
     fclose(out);
     printf("\nFile was saved as Letters.c\n\n");
     }
}
